main(){
    PATH_FILE=$(pwd)
    PYTHON_PATH=python3
    ANNOGESIC_PATH=annogesic #### specify the path of annogesic
    ANNOGESIC_FOLDER=ANNOgesic_NC_000913_dRNA-Seq
    FTP_SOURCE=ftp://ftp.ncbi.nlm.nih.gov/genomes/refseq/bacteria/Escherichia_coli/latest_assembly_versions/GCF_000005845.2_ASM584v2/
    SEQ_ID=NC_000913.3
    TEX_FOLDER=$ANNOGESIC_FOLDER/input/wigs/tex_notex

    TEX_LIBS="$TEX_FOLDER/GSM1331409_LB_0.4_B1_TEX_neg_L1_GA_forward.wig:notex:1:a:+ \
$TEX_FOLDER/GSM1331409_LB_0.4_B1_TEX_neg_L1_GA_reverse.wig:notex:1:a:- \
$TEX_FOLDER/GSM1331410_LB_0.4_B1_TEX_pos_L1_GA_forward.wig:tex:1:a:+ \
$TEX_FOLDER/GSM1331410_LB_0.4_B1_TEX_pos_L1_GA_reverse.wig:tex:1:a:- \
$TEX_FOLDER/GSM1331411_LB_0.4_B2_TEX_neg_L1_HS1_forward.wig:notex:1:b:+ \
$TEX_FOLDER/GSM1331411_LB_0.4_B2_TEX_neg_L1_HS1_reverse.wig:notex:1:b:- \
$TEX_FOLDER/GSM1331413_LB_0.4_B2_TEX_pos_L1_HS1_forward.wig:tex:1:b:+ \
$TEX_FOLDER/GSM1331413_LB_0.4_B2_TEX_pos_L1_HS1_reverse.wig:tex:1:b:- \
$TEX_FOLDER/GSM1331412_LB_0.4_B2_TEX_neg_L1_HS2_forward.wig:notex:1:c:+ \
$TEX_FOLDER/GSM1331412_LB_0.4_B2_TEX_neg_L1_HS2_reverse.wig:notex:1:c:- \
$TEX_FOLDER/GSM1331414_LB_0.4_B2_TEX_pos_L1_HS2_forward.wig:tex:1:c:+ \
$TEX_FOLDER/GSM1331414_LB_0.4_B2_TEX_pos_L1_HS2_reverse.wig:tex:1:c:- \
$TEX_FOLDER/GSM1331425_M63_0.4_B1_TEX_neg_L1_GA_forward.wig:notex:2:a:+ \
$TEX_FOLDER/GSM1331425_M63_0.4_B1_TEX_neg_L1_GA_reverse.wig:notex:2:a:- \
$TEX_FOLDER/GSM1331426_M63_0.4_B1_TEX_pos_L1_GA_forward.wig:tex:2:a:+ \
$TEX_FOLDER/GSM1331426_M63_0.4_B1_TEX_pos_L1_GA_reverse.wig:tex:2:a:- \
$TEX_FOLDER/GSM1331427_M63_0.4_B2_TEX_neg_L1_HS1_forward.wig:notex:2:b:+ \
$TEX_FOLDER/GSM1331427_M63_0.4_B2_TEX_neg_L1_HS1_reverse.wig:notex:2:b:- \
$TEX_FOLDER/GSM1331429_M63_0.4_B2_TEX_pos_L1_HS1_forward.wig:tex:2:b:+ \
$TEX_FOLDER/GSM1331429_M63_0.4_B2_TEX_pos_L1_HS1_reverse.wig:tex:2:b:- \
$TEX_FOLDER/GSM1331428_M63_0.4_B2_TEX_neg_L1_HS2_forward.wig:notex:2:c:+ \
$TEX_FOLDER/GSM1331428_M63_0.4_B2_TEX_neg_L1_HS2_reverse.wig:notex:2:c:- \
$TEX_FOLDER/GSM1331430_M63_0.4_B2_TEX_pos_L1_HS2_forward.wig:tex:2:c:+ \
$TEX_FOLDER/GSM1331430_M63_0.4_B2_TEX_pos_L1_HS2_reverse.wig:tex:2:c:- \
$TEX_FOLDER/GSM1331415_LB_2.0_B1_TEX_neg_L1_GA_forward.wig:notex:3:a:+ \
$TEX_FOLDER/GSM1331415_LB_2.0_B1_TEX_neg_L1_GA_reverse.wig:notex:3:a:- \
$TEX_FOLDER/GSM1331417_LB_2.0_B1_TEX_pos_L1_GA_forward.wig:tex:3:a:+ \
$TEX_FOLDER/GSM1331417_LB_2.0_B1_TEX_pos_L1_GA_reverse.wig:tex:3:a:- \
$TEX_FOLDER/GSM1331416_LB_2.0_B1_TEX_neg_L2_HS2_forward.wig:notex:3:b:+ \
$TEX_FOLDER/GSM1331416_LB_2.0_B1_TEX_neg_L2_HS2_reverse.wig:notex:3:b:- \
$TEX_FOLDER/GSM1331418_LB_2.0_B1_TEX_pos_L2_HS2_forward.wig:tex:3:b:+ \
$TEX_FOLDER/GSM1331418_LB_2.0_B1_TEX_pos_L2_HS2_reverse.wig:tex:3:b:- \
$TEX_FOLDER/GSM1331419_LB_2.0_B2_TEX_neg_L1_HS1_forward.wig:notex:3:c:+ \
$TEX_FOLDER/GSM1331419_LB_2.0_B2_TEX_neg_L1_HS1_reverse.wig:notex:3:c:- \
$TEX_FOLDER/GSM1331422_LB_2.0_B2_TEX_pos_L1_HS1_forward.wig:tex:3:c:+ \
$TEX_FOLDER/GSM1331422_LB_2.0_B2_TEX_pos_L1_HS1_reverse.wig:tex:3:c:- \
$TEX_FOLDER/GSM1331420_LB_2.0_B2_TEX_neg_L1_HS2_forward.wig:notex:3:d:+ \
$TEX_FOLDER/GSM1331420_LB_2.0_B2_TEX_neg_L1_HS2_reverse.wig:notex:3:d:- \
$TEX_FOLDER/GSM1331423_LB_2.0_B2_TEX_pos_L1_HS2_forward.wig:tex:3:d:+ \
$TEX_FOLDER/GSM1331423_LB_2.0_B2_TEX_pos_L1_HS2_reverse.wig:tex:3:d:- \
$TEX_FOLDER/GSM1331421_LB_2.0_B2_TEX_neg_L2_HS2_forward.wig:notex:3:e:+ \
$TEX_FOLDER/GSM1331421_LB_2.0_B2_TEX_neg_L2_HS2_reverse.wig:notex:3:e:- \
$TEX_FOLDER/GSM1331424_LB_2.0_B2_TEX_pos_L2_HS2_forward.wig:tex:3:e:+ \
$TEX_FOLDER/GSM1331424_LB_2.0_B2_TEX_pos_L2_HS2_reverse.wig:tex:3:e:-"

##### Please remove # before the commands that you want to run
##### Please install ANNOgesic properly or use Docker container

    set_up_analysis_folder
#    get_wig_and_read_files
#    get_input_files    
#    Optimize_TSS
#    TSS_prediction
#    processing_site_prediction
#    Transcript_detection
#    Terminator_prediction
#    utr_detection
#    operon_detection
#    promoter_detection
#    sRNA_detection
#    sORF_detection
#    sRNA_target
#    riboswitch_and_RNA_thermometer
#    crispr
#    merge_features
}


set_up_analysis_folder(){
    if ! [ -d $ANNOGESIC_FOLDER ]
    then
        $ANNOGESIC_PATH create \
	-pj $ANNOGESIC_FOLDER
    fi
}

get_wig_and_read_files(){
    #### Download and unzip wiggle files
    wget -cP $ANNOGESIC_FOLDER/input/wigs/tex_notex ftp://ftp.ncbi.nlm.nih.gov/geo/series/GSE55nnn/GSE55199/suppl/GSE55199_RAW.tar
    cd $ANNOGESIC_FOLDER/input/wigs/tex_notex
    tar -xf GSE55199_RAW.tar
    rm GSE55199_RAW.tar
    for FILE in $(ls)
    do
        gunzip ${FILE}
    done
    cd ../../../../

    #### Chromosome names of the wiggle files are not the same as fasta files.
    #### We can use replace_seq_id.py to modify them.
    wget https://raw.githubusercontent.com/Sung-Huan/ANNOgesic/master/tutorial_data/replace_seq_id.py
    python3 replace_seq_id.py -i $ANNOGESIC_FOLDER/input/wigs/tex_notex -n NC_000913.3
    rm replace_seq_id.py
}

get_input_files(){
    $ANNOGESIC_PATH \
	get_input_files \
	-F $FTP_SOURCE \
	-g \
	-f \
	-e \
	-k \
	-p \
	-r \
	-pj $ANNOGESIC_FOLDER
}

Optimize_TSS(){
    $ANNOGESIC_PATH \
        optimize_tss_ps \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -tl $TEX_LIBS \
        -cn Log -s 25 \
        -m manual_TSS/Escherichia_coli_MG1655_manual_TSS.gff \
        -le ${SEQ_ID}:200000 \
        -rt all_2 \
        -pj $ANNOGESIC_FOLDER
}

TSS_prediction(){
    $ANNOGESIC_PATH \
        tss_ps \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -tl $TEX_LIBS \
	-cn LB_0.4 M63_0.4 LB_2.0 \
        -he 0.5 \
        -rh 0.2 \
        -fa 1.6 \
        -rf 0.7 \
        -bh 0.037 \
        -ef 0.1 \
        -pf 0.2 \
        -rt 1_2 2_2 3_3 \
        -le NC_000913.3:200000 \
	-p TSS \
        -m manual_TSS/Escherichia_coli_MG1655_manual_TSS.gff \
        -pj $ANNOGESIC_FOLDER
}

processing_site_prediction()
{
    $ANNOGESIC_PATH \
        tss_ps \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -tl $TEX_LIBS \
        -cn LB_0.4 M63_0.4 LB_2.0 \
        -he 0.3 \
        -rh 0.2 \
        -fa 2.0 \
        -rf 0.5 \
        -bh 0.0 \
        -ef 1.5 \
        -pf 1.5 \
        -rt 1_2 2_2 3_3 \
        -p PS \
        -pj $ANNOGESIC_FOLDER
}

Transcript_detection(){
    $ANNOGESIC_PATH \
        transcript \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -tl $TEX_LIBS \
        -rt 1_2 2_2 3_3 \
	-cf gene CDS \
        -ct $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
        -pj $ANNOGESIC_FOLDER
}

Terminator_prediction(){
    $ANNOGESIC_PATH \
        terminator \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
        -tl $TEX_LIBS \
        -rt 1_2 2_2 3_3 \
        -pj $ANNOGESIC_FOLDER
}

utr_detection(){
    $ANNOGESIC_PATH \
        utr \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -t $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
        -a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
        -e $ANNOGESIC_FOLDER/output/terminators/gffs/best_candidates/${SEQ_ID}_term.gff \
        -pj $ANNOGESIC_FOLDER
}

operon_detection(){
    $ANNOGESIC_PATH \
        operon \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -t $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
        -a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
        -u5 $ANNOGESIC_FOLDER/output/UTRs/5UTRs/gffs/${SEQ_ID}_5UTR.gff \
        -u3 $ANNOGESIC_FOLDER/output/UTRs/3UTRs/gffs/${SEQ_ID}_3UTR.gff \
        -e $ANNOGESIC_FOLDER/output/terminators/gffs/best_candidates/${SEQ_ID}_term.gff \
        -pj $ANNOGESIC_FOLDER
}

promoter_detection(){
    #### If MEME or GLAM2 cannot run in parallels, please install MPI (OpenMPI or MPICH).
    #### Otherwise, please remove -pl 10.
    $ANNOGESIC_PATH \
        promoter \
        -t $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -w 45 \
        -pl 10 \
        -pj $ANNOGESIC_FOLDER
}

sRNA_detection(){
    #### If you have no sRNA database, you can use BSRD.
    wget -cP $ANNOGESIC_FOLDER/input/databases/ https://raw.githubusercontent.com/Sung-Huan/ANNOgesic/master/database/sRNA_database_BSRD.fa
    #### If you have no nr databse, please download it.
    wget -cP $ANNOGESIC_FOLDER/input/databases/ ftp://ftp.ncbi.nih.gov/blast/db/FASTA/nr.gz
    gunzip $ANNOGESIC_FOLDER/input/databases/nr.gz
    mv $ANNOGESIC_FOLDER/input/databases/nr $ANNOGESIC_FOLDER/input/databases/nr.fa


    $ANNOGESIC_PATH \
        srna \
        -d tss blast_srna sec_str blast_nr \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -t $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
        -p $ANNOGESIC_FOLDER/output/processing_sites/gffs/${SEQ_ID}_processing.gff \
        -a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -e $ANNOGESIC_FOLDER/output/terminators/gffs/best_candidates/${SEQ_ID}_term.gff \
        -pt $ANNOGESIC_FOLDER/output/promoters/${SEQ_ID}/MEME/promoter_motifs_${SEQ_ID}_allgenome_all_types_45_nt/meme.csv \
        -pn MOTIF_1 \
        -m \
        -u \
	-cs \
        -sf \
        -nf \
        -nd $ANNOGESIC_FOLDER/input/databases/nr \
	-sd $ANNOGESIC_FOLDER/input/databases/sRNA_database_BSRD \
	-tl $TEX_LIBS \
        -rt 1_2 2_2 3_3 \
        -pj $ANNOGESIC_FOLDER
}

sORF_detection(){
    $ANNOGESIC_PATH \
        sorf \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -t $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
        -a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
	-f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -s $ANNOGESIC_FOLDER/output/sRNAs/gffs/best_candidates/${SEQ_ID}_sRNA.gff \
        -tl $TEX_LIBS \
        -rt 1_2 2_2 3_3 -u \
        -pj $ANNOGESIC_FOLDER
}

sRNA_target(){
    $ANNOGESIC_PATH \
        srna_target \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -s $ANNOGESIC_FOLDER/output/sRNAs/gffs/best_candidates/${SEQ_ID}_sRNA.gff \
        -q all \
        -p IntaRNA RNAplex RNAup \
	-mi H \
        -pj $ANNOGESIC_FOLDER
}

riboswitch_and_RNA_thermometer(){
    #### You can download the riboswitch and RNA thermometer ID list of Rfam from our Git repository.
    wget -cP $ANNOGESIC_FOLDER/input/riboswitch_ID_file/ https://raw.githubusercontent.com/Sung-Huan/ANNOgesic/master/database/Rfam_riboswitch_ID.csv
    wget -cP $ANNOGESIC_FOLDER/input/RNA_thermometer_ID_file/ https://raw.githubusercontent.com/Sung-Huan/ANNOgesic/master/database/Rfam_RNA_thermometer_ID.csv
    #### If you have no Rfam database, please download it.
    wget -cP $ANNOGESIC_FOLDER/input/databases ftp://ftp.ebi.ac.uk/pub/databases/Rfam/12.0/Rfam.tar.gz
    cd $ANNOGESIC_FOLDER/input/databases
    tar -zxvf Rfam.tar.gz
    rm Rfam.tar.gz
    cd ../../../

    $ANNOGESIC_PATH \
        riboswitch_thermometer \
	-g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
	-f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
	-ri $ANNOGESIC_FOLDER/input/riboswitch_ID_file/Rfam_riboswitch_ID.csv \
	-ti $ANNOGESIC_FOLDER/input/RNA_thermometer_ID_file/Rfam_RNA_thermometer_ID.csv \
	-R $ANNOGESIC_FOLDER/input/databases/CMs/Rfam.cm \
	-a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
	-t $ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
	-pj $ANNOGESIC_FOLDER
}

crispr(){
    $ANNOGESIC_PATH \
        crispr \
        -g $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
        -f $ANNOGESIC_FOLDER/input/references/fasta_files/${SEQ_ID}.fa \
        -pj $ANNOGESIC_FOLDER
}

merge_features(){
    ALL_FEATURES="$ANNOGESIC_FOLDER/output/TSSs/gffs/${SEQ_ID}_TSS.gff \
                  $ANNOGESIC_FOLDER/input/references/annotations/${SEQ_ID}.gff \
                  $ANNOGESIC_FOLDER/output/UTRs/5UTRs/gffs/${SEQ_ID}_5UTR.gff \
                  $ANNOGESIC_FOLDER/output/UTRs/3UTRs/gffs/${SEQ_ID}_3UTR.gff \
                  $ANNOGESIC_FOLDER/output/terminators/gffs/best_candidates/${SEQ_ID}_term.gff \
                  $ANNOGESIC_FOLDER/output/processing_sites/gffs/${SEQ_ID}_processing.gff \
                  $ANNOGESIC_FOLDER/output/sRNAs/gffs/best_candidates/${SEQ_ID}_sRNA.gff \
                  $ANNOGESIC_FOLDER/output/sORFs/gffs/best_candidates/${SEQ_ID}_sORF.gff \
                  $ANNOGESIC_FOLDER/output/riboswitches/gffs/${SEQ_ID}_riboswitch.gff \
                  $ANNOGESIC_FOLDER/output/RNA_thermometers/gffs/${SEQ_ID}_RNA_thermometer.gff \
                  $ANNOGESIC_FOLDER/output/crisprs/gffs/best_candidates/${SEQ_ID}_CRISPR.gff"

    $ANNOGESIC_PATH \
        merge_features \
        -a $ANNOGESIC_FOLDER/output/transcripts/gffs/${SEQ_ID}_transcript.gff \
        -of $ALL_FEATURES \
        -op ${SEQ_ID} \
        -s RefSeq \
        -pj $ANNOGESIC_FOLDER
}

main
